window.Gleam.initSearch([{"doc":"domu","title":"domu","content":"# domu\n\nDOM library for Gleam\n\n&lt;!--\n[![Package Version](https://img.shields.io/hexpm/v/domu)](https://hex.pm/packages/domu)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/domu/)\n--&gt;\n\n```sh\ngleam add domu\n```\n```gleam\nimport domu/document\nimport domu/node\n\npub fn main() {\n  let doc = document.document()\n  let body = doc |&gt; document.body\n  let el = doc |&gt; document.create_element(&quot;p&quot;)\n  el |&gt; node.set_text_content(&quot;Hello, world!&quot;)\n  body |&gt; node.append_child(el)\n}\n```\n\n&lt;!-- Further documentation can be found at &lt;https://hexdocs.pm/domu&gt;. --&gt;\n\n## Development\n\n### Build\n\n```sh\ntask build # or `task build --watch` to watch for changes and rebuild\n```\n\n### Test\n\n```sh\ntask test\n```\n\n### Generate docs\n\n```sh\ntask docs\n```\n\n### Clean\n\n```sh\ntask clean\n```\n","url":"index.html"},{"doc":"domu/types","title":"AbortSignal","content":"pub type AbortSignal =\n  AbortSignalLike(Concrete)\n\n\nSynonyms:\ndomu/types.AbortSignal\ndomu/types AbortSignal","url":"domu/types.html#AbortSignal"},{"doc":"domu/types","title":"AbortSignalLike","content":"pub type AbortSignalLike(a) =\n  EventTargetLike(TagAbortSignal(a))\n\n\nSynonyms:\ndomu/types.AbortSignalLike\ndomu/types AbortSignalLike","url":"domu/types.html#AbortSignalLike"},{"doc":"domu/types","title":"Concrete","content":"pub type Concrete\n\n\nSynonyms:\ndomu/types.Concrete\ndomu/types Concrete","url":"domu/types.html#Concrete"},{"doc":"domu/types","title":"Document","content":"pub type Document =\n  DocumentLike(Concrete)\n\n\nSynonyms:\ndomu/types.Document\ndomu/types Document","url":"domu/types.html#Document"},{"doc":"domu/types","title":"DocumentLike","content":"pub type DocumentLike(a) =\n  NodeLike(TagDocument(a))\n\n\nSynonyms:\ndomu/types.DocumentLike\ndomu/types DocumentLike","url":"domu/types.html#DocumentLike"},{"doc":"domu/types","title":"Element","content":"pub type Element =\n  ElementLike(Concrete)\n\n\nSynonyms:\ndomu/types.Element\ndomu/types Element","url":"domu/types.html#Element"},{"doc":"domu/types","title":"ElementLike","content":"pub type ElementLike(a) =\n  NodeLike(TagElement(a))\n\n\nSynonyms:\ndomu/types.ElementLike\ndomu/types ElementLike","url":"domu/types.html#ElementLike"},{"doc":"domu/types","title":"Event","content":"pub type Event\n\n\nSynonyms:\ndomu/types.Event\ndomu/types Event","url":"domu/types.html#Event"},{"doc":"domu/types","title":"EventTarget","content":"pub type EventTarget =\n  EventTargetLike(Concrete)\n\n\nSynonyms:\ndomu/types.EventTarget\ndomu/types EventTarget","url":"domu/types.html#EventTarget"},{"doc":"domu/types","title":"EventTargetLike","content":"pub type EventTargetLike(a)\n\n\nSynonyms:\ndomu/types.EventTargetLike\ndomu/types EventTargetLike","url":"domu/types.html#EventTargetLike"},{"doc":"domu/types","title":"HTMLAnchorElement","content":"pub type HTMLAnchorElement =\n  HTMLAnchorElementLike(Concrete)\n\n\nSynonyms:\ndomu/types.HTMLAnchorElement\ndomu/types HTMLAnchorElement","url":"domu/types.html#HTMLAnchorElement"},{"doc":"domu/types","title":"HTMLAnchorElementLike","content":"pub type HTMLAnchorElementLike(a) =\n  HTMLElementLike(TagHTMLAnchorElement(a))\n\n\nSynonyms:\ndomu/types.HTMLAnchorElementLike\ndomu/types HTMLAnchorElementLike","url":"domu/types.html#HTMLAnchorElementLike"},{"doc":"domu/types","title":"HTMLBodyElement","content":"pub type HTMLBodyElement =\n  HTMLBodyElementLike(Concrete)\n\n\nSynonyms:\ndomu/types.HTMLBodyElement\ndomu/types HTMLBodyElement","url":"domu/types.html#HTMLBodyElement"},{"doc":"domu/types","title":"HTMLBodyElementLike","content":"pub type HTMLBodyElementLike(a) =\n  HTMLElementLike(TagHTMLBodyElement(a))\n\n\nSynonyms:\ndomu/types.HTMLBodyElementLike\ndomu/types HTMLBodyElementLike","url":"domu/types.html#HTMLBodyElementLike"},{"doc":"domu/types","title":"HTMLElement","content":"pub type HTMLElement =\n  HTMLElementLike(Concrete)\n\n\nSynonyms:\ndomu/types.HTMLElement\ndomu/types HTMLElement","url":"domu/types.html#HTMLElement"},{"doc":"domu/types","title":"HTMLElementLike","content":"pub type HTMLElementLike(a) =\n  ElementLike(TagHTMLElement(a))\n\n\nSynonyms:\ndomu/types.HTMLElementLike\ndomu/types HTMLElementLike","url":"domu/types.html#HTMLElementLike"},{"doc":"domu/types","title":"Node","content":"pub type Node =\n  NodeLike(Concrete)\n\n\nSynonyms:\ndomu/types.Node\ndomu/types Node","url":"domu/types.html#Node"},{"doc":"domu/types","title":"NodeLike","content":"pub type NodeLike(a) =\n  EventTargetLike(TagNode(a))\n\n\nSynonyms:\ndomu/types.NodeLike\ndomu/types NodeLike","url":"domu/types.html#NodeLike"},{"doc":"domu/types","title":"TagAbortSignal","content":"pub type TagAbortSignal(a)\n\n\nSynonyms:\ndomu/types.TagAbortSignal\ndomu/types TagAbortSignal","url":"domu/types.html#TagAbortSignal"},{"doc":"domu/types","title":"TagDocument","content":"pub type TagDocument(a)\n\n\nSynonyms:\ndomu/types.TagDocument\ndomu/types TagDocument","url":"domu/types.html#TagDocument"},{"doc":"domu/types","title":"TagElement","content":"pub type TagElement(a)\n\n\nSynonyms:\ndomu/types.TagElement\ndomu/types TagElement","url":"domu/types.html#TagElement"},{"doc":"domu/types","title":"TagHTMLAnchorElement","content":"pub type TagHTMLAnchorElement(a)\n\n\nSynonyms:\ndomu/types.TagHTMLAnchorElement\ndomu/types TagHTMLAnchorElement","url":"domu/types.html#TagHTMLAnchorElement"},{"doc":"domu/types","title":"TagHTMLBodyElement","content":"pub type TagHTMLBodyElement(a)\n\n\nSynonyms:\ndomu/types.TagHTMLBodyElement\ndomu/types TagHTMLBodyElement","url":"domu/types.html#TagHTMLBodyElement"},{"doc":"domu/types","title":"TagHTMLElement","content":"pub type TagHTMLElement(a)\n\n\nSynonyms:\ndomu/types.TagHTMLElement\ndomu/types TagHTMLElement","url":"domu/types.html#TagHTMLElement"},{"doc":"domu/types","title":"TagNode","content":"pub type TagNode(a)\n\n\nSynonyms:\ndomu/types.TagNode\ndomu/types TagNode","url":"domu/types.html#TagNode"},{"doc":"domu/types","title":"domu/types","content":"","url":"domu/types.html"},{"doc":"domu/add_event_listener_options","title":"AddEventListenerOptions","content":"pub type AddEventListenerOptions(a) {\n  AddEventListenerOptions(\n    capture: Bool,\n    once: Bool,\n    passive: Option(Bool),\n    abort_signal: Option(AbortSignalLike(a)),\n  )\n}\n\nAddEventListenerOptions(\n  capture: Bool,\n  once: Bool,\n  passive: Option(Bool),\n  abort_signal: Option(AbortSignalLike(a)),\n)\n\n\nSynonyms:\ndomu/add_event_listener_options.AddEventListenerOptions\ndomu/add_event_listener_options AddEventListenerOptions","url":"domu/add_event_listener_options.html#AddEventListenerOptions"},{"doc":"domu/add_event_listener_options","title":"abort_signal","content":"pub fn abort_signal(\n  options: AddEventListenerOptions(a),\n  value: EventTargetLike(TagAbortSignal(b)),\n) -&gt; AddEventListenerOptions(b)\n\nSynonyms:\ndomu/add_event_listener_options.abort_signal\ndomu/add_event_listener_options abort_signal","url":"domu/add_event_listener_options.html#abort_signal"},{"doc":"domu/add_event_listener_options","title":"capture","content":"pub fn capture(\n  options: AddEventListenerOptions(a),\n  value: Bool,\n) -&gt; AddEventListenerOptions(a)\n\nSynonyms:\ndomu/add_event_listener_options.capture\ndomu/add_event_listener_options capture","url":"domu/add_event_listener_options.html#capture"},{"doc":"domu/add_event_listener_options","title":"default","content":"pub fn default() -&gt; AddEventListenerOptions(a)\n\nSynonyms:\ndomu/add_event_listener_options.default\ndomu/add_event_listener_options default","url":"domu/add_event_listener_options.html#default"},{"doc":"domu/add_event_listener_options","title":"once","content":"pub fn once(\n  options: AddEventListenerOptions(a),\n  value: Bool,\n) -&gt; AddEventListenerOptions(a)\n\nSynonyms:\ndomu/add_event_listener_options.once\ndomu/add_event_listener_options once","url":"domu/add_event_listener_options.html#once"},{"doc":"domu/add_event_listener_options","title":"passive","content":"pub fn passive(\n  options: AddEventListenerOptions(a),\n  value: Bool,\n) -&gt; AddEventListenerOptions(a)\n\nSynonyms:\ndomu/add_event_listener_options.passive\ndomu/add_event_listener_options passive","url":"domu/add_event_listener_options.html#passive"},{"doc":"domu/add_event_listener_options","title":"domu/add_event_listener_options","content":"","url":"domu/add_event_listener_options.html"},{"doc":"domu/document","title":"body","content":"pub fn body(\n  document: EventTargetLike(TagNode(TagDocument(a))),\n) -&gt; EventTargetLike(\n  TagNode(\n    TagElement(TagHTMLElement(TagHTMLBodyElement(Concrete))),\n  ),\n)\n Returns the `document.body` as an `HTMLBodyElement` .\n\n Note that `document.body` itself returns `null` when the `&lt;body&gt;` tag hasn&#39;t been loaded yet.\n This function is defined for convenience.\n\n For safer handling, use `body_option` instead.\n\n [MDN Reference](https://developer.mozilla.org/docs/Web/API/Document/body)\nSynonyms:\ndomu/document.body\ndomu/document body","url":"domu/document.html#body"},{"doc":"domu/document","title":"body_option","content":"pub fn body_option(\n  document: EventTargetLike(TagNode(TagDocument(a))),\n) -&gt; Option(\n  EventTargetLike(\n    TagNode(\n      TagElement(TagHTMLElement(TagHTMLBodyElement(Concrete))),\n    ),\n  ),\n)\n Returns the `document.body` as an `Option(HTMLBodyElement)` .\n\n This function safely handles the case where `document.body` is `null` .\n\n [MDN Reference](https://developer.mozilla.org/docs/Web/API/Document/body)\nSynonyms:\ndomu/document.body_option\ndomu/document body_option","url":"domu/document.html#body_option"},{"doc":"domu/document","title":"create_element","content":"pub fn create_element(\n  document: EventTargetLike(TagNode(TagDocument(a))),\n  tag_name: String,\n) -&gt; EventTargetLike(\n  TagNode(TagElement(TagHTMLElement(Concrete))),\n)\n [MDN Reference](https://developer.mozilla.org/docs/Web/API/Document/createElement)\nSynonyms:\ndomu/document.create_element\ndomu/document create_element","url":"domu/document.html#create_element"},{"doc":"domu/document","title":"create_element_a","content":"pub fn create_element_a(\n  document: EventTargetLike(TagNode(TagDocument(a))),\n) -&gt; EventTargetLike(\n  TagNode(\n    TagElement(TagHTMLElement(TagHTMLAnchorElement(Concrete))),\n  ),\n)\n\nSynonyms:\ndomu/document.create_element_a\ndomu/document create_element_a","url":"domu/document.html#create_element_a"},{"doc":"domu/document","title":"document","content":"pub fn document() -&gt; EventTargetLike(\n  TagNode(TagDocument(Concrete)),\n)\n [MDN Reference](https://developer.mozilla.org/docs/Web/API/Document)\nSynonyms:\ndomu/document.document\ndomu/document document","url":"domu/document.html#document"},{"doc":"domu/document","title":"of_node","content":"pub fn of_node(\n  node: EventTargetLike(TagNode(a)),\n) -&gt; Option(EventTargetLike(TagNode(TagDocument(Concrete))))\n Downcasts `Node` to `Document` if possible.\nSynonyms:\ndomu/document.of_node\ndomu/document of_node","url":"domu/document.html#of_node"},{"doc":"domu/document","title":"domu/document","content":"","url":"domu/document.html"},{"doc":"domu/event_target","title":"add_event_listener","content":"pub fn add_event_listener(\n  event_target: EventTargetLike(a),\n  event_type: String,\n  listener: fn(Event) -&gt; Nil,\n  options: Option(AddEventListenerOptions(b)),\n) -&gt; Nil\n\nSynonyms:\ndomu/event_target.add_event_listener\ndomu/event_target add_event_listener","url":"domu/event_target.html#add_event_listener"},{"doc":"domu/event_target","title":"domu/event_target","content":"","url":"domu/event_target.html"},{"doc":"domu/html_anchor_element","title":"href","content":"pub fn href(\n  element: EventTargetLike(\n    TagNode(TagElement(TagHTMLElement(TagHTMLAnchorElement(a)))),\n  ),\n) -&gt; String\n [MDN Reference](https://developer.mozilla.org/docs/Web/API/HTMLAnchorElement/href)\nSynonyms:\ndomu/html_anchor_element.href\ndomu/html_anchor_element href","url":"domu/html_anchor_element.html#href"},{"doc":"domu/html_anchor_element","title":"set_href","content":"pub fn set_href(\n  element: EventTargetLike(\n    TagNode(TagElement(TagHTMLElement(TagHTMLAnchorElement(a)))),\n  ),\n  href: String,\n) -&gt; Nil\n [MDN Reference](https://developer.mozilla.org/docs/Web/API/HTMLAnchorElement/href)\nSynonyms:\ndomu/html_anchor_element.set_href\ndomu/html_anchor_element set_href","url":"domu/html_anchor_element.html#set_href"},{"doc":"domu/html_anchor_element","title":"domu/html_anchor_element","content":"","url":"domu/html_anchor_element.html"},{"doc":"domu/node_list","title":"Live","content":"pub type Live\n\n\nSynonyms:\ndomu/node_list.Live\ndomu/node_list Live","url":"domu/node_list.html#Live"},{"doc":"domu/node_list","title":"NodeList","content":"pub type NodeList(a)\n\n\nSynonyms:\ndomu/node_list.NodeList\ndomu/node_list NodeList","url":"domu/node_list.html#NodeList"},{"doc":"domu/node_list","title":"Static","content":"pub type Static\n\n\nSynonyms:\ndomu/node_list.Static\ndomu/node_list Static","url":"domu/node_list.html#Static"},{"doc":"domu/node_list","title":"entries","content":"pub fn entries(\n  node_list: NodeList(a),\n) -&gt; Iterator(#(Int, EventTargetLike(TagNode(Concrete))))\n\nSynonyms:\ndomu/node_list.entries\ndomu/node_list entries","url":"domu/node_list.html#entries"},{"doc":"domu/node_list","title":"item","content":"pub fn item(\n  node_list: NodeList(a),\n  index: Int,\n) -&gt; Option(EventTargetLike(TagNode(Concrete)))\n\nSynonyms:\ndomu/node_list.item\ndomu/node_list item","url":"domu/node_list.html#item"},{"doc":"domu/node_list","title":"item_","content":"pub fn item_(\n  node_list: NodeList(a),\n  index: Int,\n) -&gt; Nullable(EventTargetLike(TagNode(Concrete)))\n\nSynonyms:\ndomu/node_list.item_\ndomu/node_list item_","url":"domu/node_list.html#item_"},{"doc":"domu/node_list","title":"length","content":"pub fn length(node_list: NodeList(a)) -&gt; Int\n\nSynonyms:\ndomu/node_list.length\ndomu/node_list length","url":"domu/node_list.html#length"},{"doc":"domu/node_list","title":"domu/node_list","content":"","url":"domu/node_list.html"},{"doc":"domu/node","title":"append_child","content":"pub fn append_child(\n  parent: EventTargetLike(TagNode(a)),\n  child: EventTargetLike(TagNode(b)),\n) -&gt; Nil\n [MDN Reference](https://developer.mozilla.org/docs/Web/API/Node/appendChild)\nSynonyms:\ndomu/node.append_child\ndomu/node append_child","url":"domu/node.html#append_child"},{"doc":"domu/node","title":"child_nodes","content":"pub fn child_nodes(\n  node: EventTargetLike(TagNode(a)),\n) -&gt; NodeList(Live)\n [MDN Reference](https://developer.mozilla.org/docs/Web/API/Node/childNodes)\nSynonyms:\ndomu/node.child_nodes\ndomu/node child_nodes","url":"domu/node.html#child_nodes"},{"doc":"domu/node","title":"clone_node","content":"pub fn clone_node(\n  node: EventTargetLike(TagNode(a)),\n  deep: Bool,\n) -&gt; EventTargetLike(TagNode(Concrete))\n [MDN Reference](https://developer.mozilla.org/docs/Web/API/Node/cloneNode)\nSynonyms:\ndomu/node.clone_node\ndomu/node clone_node","url":"domu/node.html#clone_node"},{"doc":"domu/node","title":"owner_document","content":"pub fn owner_document(\n  node: EventTargetLike(TagNode(a)),\n) -&gt; Option(EventTargetLike(TagNode(TagDocument(Concrete))))\n [MDN Reference](https://developer.mozilla.org/docs/Web/API/Node/ownerDocument)\nSynonyms:\ndomu/node.owner_document\ndomu/node owner_document","url":"domu/node.html#owner_document"},{"doc":"domu/node","title":"set_text_content","content":"pub fn set_text_content(\n  node: EventTargetLike(TagNode(a)),\n  text: String,\n) -&gt; Nil\n Sets `textContent` property of `Node`\n\n [MDN Reference](https://developer.mozilla.org/docs/Web/API/Node/textContent)\nSynonyms:\ndomu/node.set_text_content\ndomu/node set_text_content","url":"domu/node.html#set_text_content"},{"doc":"domu/node","title":"text_content","content":"pub fn text_content(\n  node: EventTargetLike(TagNode(a)),\n) -&gt; Option(String)\n Gets `textContent` property of `Node`\n\n [MDN Reference](https://developer.mozilla.org/docs/Web/API/Node/textContent)\nSynonyms:\ndomu/node.text_content\ndomu/node text_content","url":"domu/node.html#text_content"},{"doc":"domu/node","title":"domu/node","content":"","url":"domu/node.html"}]);